package utils

const (
	minUsername    = "2"
	maxUsername    = "20"
	minPassword    = "6"
	MinPassword    = 6
	maxPassword    = "64"
	MaxPassword    = 64
	minScannerName = "3"
	maxScannerName = "16"

	LenHeaderXAuthorization = 36
	lenHeaderXAuthorization = "36"
	LenUserId               = 36

	HeaderXAuthorization = "X-Authorization"

	MaxAvatarSize = 5 * 1024 * 1024 // 5 MB

	GroupTaskLockedTime = 3 // seconds - need to be equal with web
)

// commands sent to web clients
const (
	SentCmdInitUserSocketConnection = 1
	SentCmdUpdateConnectedUsers     = 2
	SentCmdNewGroupTaskStarted      = 3
	SentCmdNewGroupTaskStep         = 4
	SentCmdUpdateGroupTaskStep      = 5
	SentCmdUpdateGroupTask          = 6
	SentCmdReloadingGroupTasks      = 7
	SentCmdGroupTasksReloaded       = 8
	SentCmdUpdateUserSessions       = 9
	SentCmdUpdateAllUsersUserAvatar = 10
	SentCmdNewScanner               = 11
	SentCmdDeleteScanner            = 12
	SentCmdUpdateScannerUsedBy      = 13
	SentCmdScanResult               = 14
	SentCmdUpdateScannerLastUsed    = 15
	SentCmdTaskLocked               = 16
	SentCmdTaskUnlocked             = 17
)

// commands received from web clients
const (
	ReceivedCmdStartGroupTasks               = 1
	ReceivedCmdTaskFailedTryAgainRunTaskStep = 2
	ReceivedCmdTaskContinueTaskStep          = 3
	ReceivedCmdReloadGroupTasks              = 4
	ReceivedCmdTaskLocking                   = 5
)

var (
	generalRules = map[string]string{
		"Username":    "required,min=" + minUsername + ",max=" + maxUsername,
		"Password":    "required", // length is checked later because sent in base64
		"SessionId":   "required,len=" + lenHeaderXAuthorization,
		"ScannerName": "required,min=" + minScannerName + ",max=" + maxScannerName,
	}
)
