package utils

import (
	"encoding/json"

	"github.com/gofiber/fiber/v2"
	"github.com/rs/zerolog/log"
)

func GetXAuhorizationHeader(c *fiber.Ctx) string {
	return c.GetReqHeaders()[HeaderXAuthorization]
}

func MarshalJson(v any) string {
	log.Debug().Msgf("MarshalJson input %s", v)

	json, err := json.Marshal(v)

	if err != nil {
		log.Error().Msgf("Failed to marshal json %s", err)
		return ""
	}

	log.Debug().Msgf("Marshal json %s", json)

	return string(json)
}
